﻿using InternetShopContracts.DataBindingModels;
using InternetShopContracts.DataViewModels;
using InternetShopDataModels.Models;
using System.ComponentModel.DataAnnotations;

namespace InternetShopDatabase.Models
{
    public class Product : IProductModel
    {
        [Required]
        public string Name { get; set; } = string.Empty;
        public int Id { get; set; }
        public ProductViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name,
        };
        public static Product Create(ProductBindingModel model)
        {
            return new Product()
            {
                Id = model.Id,
                Name = model.Name,
            };
        }
        public void Update(ProductBindingModel model)
        {
            Name = model.Name;
        }
    }
}
