using InternetShopContracts.LogicsContracts;
using InternetShopContracts.StorageContracts;
using InternetShopDatabase.Storages;
using InternetShopForms.Orders;
using InternetShopForms.Products;
using InternetShopLogics.Logics;
using Microsoft.Extensions.DependencyInjection;

namespace InternetShopForms
{
    internal static class Program
    {
        private static ServiceProvider? _serviceProvider;
        public static ServiceProvider? ServiceProvider => _serviceProvider;
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();

            var services = new ServiceCollection();
            ConfigureServices(services);
            _serviceProvider = services.BuildServiceProvider();

            Application.Run(_serviceProvider.GetRequiredService<FormOrdersList>());
        }
        private static void ConfigureServices(ServiceCollection services)
        {
            services.AddTransient<IOrderStorage, OrderStorage>();
            services.AddTransient<IProductStorage, ProductStorage>();
            services.AddTransient<IOrderLogic, OrderLogic>();
            services.AddTransient<IProductLogic, ProductLogic>();
            services.AddTransient<FormOrdersList>();
            services.AddTransient<FormOrderEdit>();
            services.AddTransient<FormProductsList>();
        }
    }
}